"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var hasExportName_1 = __importDefault(require("./hasExportName"));
var hasHOC_1 = __importDefault(require("./hasHOC"));
var isPageToIgnore_1 = __importDefault(require("./isPageToIgnore"));
var templateWithLoader_1 = __importDefault(require("./templateWithLoader"));
var templateWithHoc_1 = __importDefault(require("./templateWithHoc"));
var constants_1 = require("./constants");
var defaultAppPath = process.cwd() + '/node_modules/next/dist/pages/_app';
var pagePath = process.cwd() + '/pages/';
function loader(rawCode) {
    if (this.resourcePath.startsWith(defaultAppPath))
        return constants_1.defaultAppJs;
    if (!this.resourcePath.startsWith(pagePath))
        return rawCode;
    var _a = this.query, hasGetInitialPropsOnAppJs = _a.hasGetInitialPropsOnAppJs, extensionsRgx = _a.extensionsRgx;
    var page = this.resourcePath.replace(pagePath, '/', '');
    var pageNoExt = page.replace(extensionsRgx, '');
    var code = rawCode.replace(constants_1.clearCommentsRgx, '');
    var typescript = page.endsWith('.ts') || page.endsWith('.tsx');
    if (!code.includes('export default'))
        return rawCode;
    if (hasGetInitialPropsOnAppJs) {
        return pageNoExt === '/_app'
            ? templateWithHoc_1.default(rawCode, { typescript: typescript })
            : rawCode;
    }
    if (pageNoExt === '/_app') {
        return templateWithHoc_1.default(rawCode, { skipInitialProps: true, typescript: typescript });
    }
    if (isPageToIgnore_1.default(page))
        return rawCode;
    var isWrapperWithExternalHOC = hasHOC_1.default(code);
    var isDynamicPage = page.includes('[');
    var isGetInitialProps = !!code.match(/\WgetInitialProps\W/g);
    var isGetServerSideProps = hasExportName_1.default(code, 'getServerSideProps');
    var isGetStaticPaths = hasExportName_1.default(code, 'getStaticPaths');
    var isGetStaticProps = hasExportName_1.default(code, 'getStaticProps');
    var hasLoader = isGetStaticProps ||
        isGetStaticPaths ||
        isGetServerSideProps ||
        isGetInitialProps;
    if (isGetInitialProps || (!hasLoader && isWrapperWithExternalHOC)) {
        return templateWithHoc_1.default(rawCode, { typescript: typescript });
    }
    var loader = isGetServerSideProps ||
        (!hasLoader && isDynamicPage && !isWrapperWithExternalHOC)
        ? 'getServerSideProps'
        : 'getStaticProps';
    return templateWithLoader_1.default(rawCode, {
        page: pageNoExt,
        typescript: typescript,
        loader: loader,
        hasLoader: hasLoader,
    });
}
exports.default = loader;
