import { clearCommentsRgx } from './constants';
import hasExportName from './hasExportName';
export default function hasHOC(rawData) {
    var hocRgx = new RegExp('[^\\(|\\| )]+\\([A-Z][^\\(|\\| )]*\\)');
    var hasWithTranslationHOC = new RegExp('import *(\\w*) *.*from *.*next-translate\\/withTranslation.*');
    if (!rawData.includes('export default'))
        return false;
    if (hasExportName(rawData, 'getStaticProps') ||
        hasExportName(rawData, 'getServerSideProps') ||
        hasExportName(rawData, 'getStaticPaths')) {
        return false;
    }
    var _a = rawData.match(hasWithTranslationHOC) || [], withTranslationName = _a[1];
    var data = rawData
        .replace(new RegExp(withTranslationName + "\\(.*\\)"), function (d) {
        return d.replace(new RegExp("(" + withTranslationName + "|\\(|\\))", 'g'), '');
    })
        .replace(clearCommentsRgx, '');
    var exportedNormally = new RegExp("export default (\\(.*\\) *=>|function)").test(data);
    if (exportedNormally)
        return false;
    var ref = (data.replace(/ /g, '').match("exportdefault*([^\\n|;]*)") ||
        [])[1];
    if (hocRgx.test(ref))
        return true;
    return (data
        .split('/n')
        .filter(function (line) { return line.includes(ref); })
        .filter(function (line) { return hocRgx.test(line); }).length > 0);
}
