var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
function nextTranslate(nextConfig) {
    if (nextConfig === void 0) { nextConfig = {}; }
    var fs = require('fs');
    var arePagesInsideSrc = fs.existsSync(process.cwd() + '/src/pages');
    var file = '/i18n.js';
    if (!fs.existsSync(process.cwd() + file))
        file = '/i18n.json';
    if (!fs.existsSync(process.cwd() + file)) {
        console.error('🚨 [next-translate] You should provide the next-translate config inside i18n.js / i18n.json root file.');
        return nextConfig;
    }
    var i18n = nextConfig.i18n || {};
    var _a = require(process.cwd() + file), locales = _a.locales, defaultLocale = _a.defaultLocale, _b = _a.loader, loader = _b === void 0 ? true : _b, pages = _a.pages, logger = _a.logger, restI18n = __rest(_a, ["locales", "defaultLocale", "loader", "pages", "logger"]);
    var migrationLink = 'https://github.com/vinissimus/next-translate/releases/tag/1.0.0';
    if (restI18n.currentPagesDir) {
        console.warn("\uD83D\uDEA8 [next-translate] \"currentPagesDir\" is no longer necessary, you can just remove it. Learn more on " + migrationLink);
    }
    if (restI18n.finalPagesDir) {
        console.warn("\uD83D\uDEA8 [next-translate] \"finalPagesDir\" is no longer necessary, you can just remove it. Learn more on " + migrationLink);
    }
    if (restI18n.localesPath) {
        console.warn("\uD83D\uDEA8 [next-translate] \"localesPath\" is no longer supported, you should replace it to \"loadLocaleFrom\". Learn more on " + migrationLink);
    }
    if (restI18n.package !== undefined) {
        console.warn("\uD83D\uDEA8 [next-translate] \"package\" is no longer supported, you should replace it to \"loadLocaleFrom\". Learn more on " + migrationLink);
    }
    var hasGetInitialPropsOnAppJs = require('./hasGetInitialPropsOnAppJs')(arePagesInsideSrc);
    return __assign(__assign({}, nextConfig), { i18n: __assign(__assign(__assign({}, i18n), restI18n), { locales: locales,
            defaultLocale: defaultLocale }), webpack: function (conf, options) {
            var config = typeof nextConfig.webpack === 'function'
                ? nextConfig.webpack(conf, options)
                : conf;
            if (!loader)
                return config;
            config.module.rules = config.module.rules.map(function (r) {
                var _a;
                if (!((_a = r === null || r === void 0 ? void 0 : r.test) === null || _a === void 0 ? void 0 : _a.test('/test.js')))
                    return r;
                var loader = {
                    loader: 'next-translate/plugin/loader',
                    options: {
                        extensionsRgx: r.test,
                        hasGetInitialPropsOnAppJs: hasGetInitialPropsOnAppJs,
                    },
                };
                var use = [];
                if (Array.isArray(r.use))
                    use = __spreadArrays(r.use, [loader]);
                else if (typeof r.use === 'object')
                    use = [r.use, loader];
                else if (r !== null && r.use === null)
                    use = [__assign({}, r), loader];
                return __assign(__assign({}, r), { use: use });
            });
            return config;
        } });
}
module.exports = nextTranslate;
