import hasExportName from './hasExportName';
import hasHOC from './hasHOC';
import isPageToIgnore from './isPageToIgnore';
import templateWithLoader from './templateWithLoader';
import templateWithHoc from './templateWithHoc';
import { clearCommentsRgx, defaultAppJs } from './constants';
var defaultAppPath = process.cwd() + '/node_modules/next/dist/pages/_app';
var pagePath = process.cwd() + '/pages/';
export default function loader(rawCode) {
    if (this.resourcePath.startsWith(defaultAppPath))
        return defaultAppJs;
    if (!this.resourcePath.startsWith(pagePath))
        return rawCode;
    var _a = this.query, hasGetInitialPropsOnAppJs = _a.hasGetInitialPropsOnAppJs, extensionsRgx = _a.extensionsRgx;
    var page = this.resourcePath.replace(pagePath, '/', '');
    var pageNoExt = page.replace(extensionsRgx, '');
    var code = rawCode.replace(clearCommentsRgx, '');
    var typescript = page.endsWith('.ts') || page.endsWith('.tsx');
    if (!code.includes('export default'))
        return rawCode;
    if (hasGetInitialPropsOnAppJs) {
        return pageNoExt === '/_app'
            ? templateWithHoc(rawCode, { typescript: typescript })
            : rawCode;
    }
    if (pageNoExt === '/_app') {
        return templateWithHoc(rawCode, { skipInitialProps: true, typescript: typescript });
    }
    if (isPageToIgnore(page))
        return rawCode;
    var isWrapperWithExternalHOC = hasHOC(code);
    var isDynamicPage = page.includes('[');
    var isGetInitialProps = !!code.match(/\WgetInitialProps\W/g);
    var isGetServerSideProps = hasExportName(code, 'getServerSideProps');
    var isGetStaticPaths = hasExportName(code, 'getStaticPaths');
    var isGetStaticProps = hasExportName(code, 'getStaticProps');
    var hasLoader = isGetStaticProps ||
        isGetStaticPaths ||
        isGetServerSideProps ||
        isGetInitialProps;
    if (isGetInitialProps || (!hasLoader && isWrapperWithExternalHOC)) {
        return templateWithHoc(rawCode, { typescript: typescript });
    }
    var loader = isGetServerSideProps ||
        (!hasLoader && isDynamicPage && !isWrapperWithExternalHOC)
        ? 'getServerSideProps'
        : 'getStaticProps';
    return templateWithLoader(rawCode, {
        page: pageNoExt,
        typescript: typescript,
        loader: loader,
        hasLoader: hasLoader,
    });
}
